#ifndef SYSCALLEXCEPTION_H
#define SYSCALLEXCEPTION_H

#include "Exception.h"

//----------------------------------------------------------------------------
class SyscallException : public Exception
{
  public:
    SyscallException(const char *message);
    SyscallException(const std::string &message);
    SyscallException(const char *message, int error);
    SyscallException(const std::string &message, int error);
    ~SyscallException();

    inline int getErrno() const { return m_errno; }

    std::string toString() const;

  protected:
    int m_errno;
};

#endif //SYSCALLEXCEPTION_H
