#ifndef MENU_IDS_H
#define MENU_IDS_H

enum MenuId
{
  ID_BACKGROUND = 0,
  ID_BACKGROUND_LABEL = 1,
  ID_BACKGROUND_HEADER = 2,

  ID_MAIN_MENU = 1000,
  ID_MAIN_MENU_NEW = 1001,
  ID_MAIN_MENU_OPTIONS = 1002,
  ID_MAIN_MENU_CREDITS = 1003,
  ID_MAIN_MENU_QUIT = 1004,

  ID_QUIT_MENU = 1100,
  ID_QUIT_MENU_LABEL = 1101,
  ID_QUIT_MENU_DO = 1102,
  ID_QUIT_MENU_DONT = 1103,

  ID_NEW_MENU = 1200,
  ID_NEW_MENU_SINGLE = 1201,
  ID_NEW_MENU_MULTI = 1202,
  ID_NEW_MENU_LOAD = 1203,
  ID_NEW_MENU_BACK = 1204,

  ID_LEVELSEL = 1210,
  ID_LEVELSEL_MISSION = 1211,
  ID_LEVELSEL_GO = 1212,
  ID_LEVELSEL_BACK = 1213,
  ID_LEVELSEL_LABEL = 1214,
  ID_LEVELSEL_HIGHSCORE = 1215,
  ID_LEVELSEL_RESUME = 1221,
  ID_LEVELSEL_PREVIEW = 1223,
  ID_LEVELSEL_PLEV = 1224,
  ID_LEVELSEL_NLEV = 1225,
  ID_LEVELSEL_FLEV = 1226,
  ID_LEVELSEL_LLEV = 1227,

  ID_OPTION_MENU = 1300,
  ID_OPTION_MENU_PLAYER = 1301,
  ID_OPTION_MENU_CTRL = 1302,
  ID_OPTION_MENU_SOUND = 1303,
  ID_OPTION_MENU_GRAPHICS = 1305,
  ID_OPTION_MENU_BACK = 1304,

  ID_PLAYER_MENU = 1310,
  ID_PLAYER_MENU_OK = 1311,
  ID_PLAYER_MENU_CANCEL = 1312,
  ID_PLAYER_MENU_NAMELAB = 1313,
  ID_PLAYER_MENU_NAMEEDIT = 1314,
  ID_PLAYER_MENU_SHIPLAB = 1315,
  ID_PLAYER_MENU_SHIPSEL = 1316,
  ID_PLAYER_MENU_SHIP_PREV = 1317,
  ID_PLAYER_MENU_SHIP_NEXT = 1318,

  ID_SOUND_MENU = 1320,
  ID_SOUND_MENU_OK = 1321,
  ID_SOUND_MENU_CANCEL = 1322,
  ID_SOUND_MENU_SOUND_VOLLAB = 1323,
  ID_SOUND_MENU_SOUND_VOLSLID = 1324,
  ID_SOUND_MENU_SOUND_VOLVAL = 1326,
  ID_SOUND_MENU_SOUND_ONOFF = 1325,
  ID_SOUND_MENU_MUSIC_VOLLAB = 1327,
  ID_SOUND_MENU_MUSIC_VOLSLID = 1328,
  ID_SOUND_MENU_MUSIC_VOLVAL = 1330,
  ID_SOUND_MENU_MUSIC_ONOFF = 1329,

  ID_GRAPHICS_MENU = 1340,
  ID_GRAPHICS_MENU_OK = 1341,
  ID_GRAPHICS_MENU_CANCEL = 1342,
  ID_GRAPHICS_MENU_FULLSCREEN_ONOFF = 1343,
  ID_GRAPHICS_MENU_FULLFRAMERATE_ONOFF = 1344,

  ID_CREDITS_MENU = 1400,
  ID_CREDITS_MENU_BACK = 1401,
  ID_CREDITS_MENU_MAINT = 1410,
  ID_CREDITS_MENU_MAINT_LST = 1411,
  ID_CREDITS_MENU_MAINT_BT = 1412,
  ID_CREDITS_MENU_PROG = 1420,
  ID_CREDITS_MENU_PROG_LST = 1421,
  ID_CREDITS_MENU_PROG_BT = 1422,
  ID_CREDITS_MENU_PROG_AG = 1423,

  ID_INGAME_MENU = 1500,
  ID_INGAME_MENU_CONTINUE = 1501,
  ID_INGAME_MENU_CTRL = 1502,
  ID_INGAME_MENU_GRAPHICS = 1505,
  ID_INGAME_MENU_SOUND = 1503,
  ID_INGAME_MENU_BACK = 1504,

  ID_HIGHSCORE_MENU = 1600,
  ID_HIGHSCORE_MENU_DONE = 1601,
  ID_HIGHSCORE_MENU_TXT = 1610,
  ID_HIGHSCORE_MENU_LABEL = 1611,
  ID_HIGHSCORE_MENU_MISSION = 1612,
  
  ID_HIGHSCORE_MENU_N1 = 1620,
  ID_HIGHSCORE_MENU_S1 = 1621,
  ID_HIGHSCORE_MENU_T1 = 1622,
  ID_HIGHSCORE_MENU_N2 = 1625,
  ID_HIGHSCORE_MENU_S2 = 1626,
  ID_HIGHSCORE_MENU_T2 = 1627,
  ID_HIGHSCORE_MENU_N3 = 1630,
  ID_HIGHSCORE_MENU_S3 = 1631,
  ID_HIGHSCORE_MENU_T3 = 1632,
  ID_HIGHSCORE_MENU_N4 = 1635,
  ID_HIGHSCORE_MENU_S4 = 1636,
  ID_HIGHSCORE_MENU_T4 = 1637,
  ID_HIGHSCORE_MENU_N5 = 1640,
  ID_HIGHSCORE_MENU_S5 = 1641,
  ID_HIGHSCORE_MENU_T5 = 1642,
  ID_HIGHSCORE_MENU_N6 = 1645,
  ID_HIGHSCORE_MENU_S6 = 1646,
  ID_HIGHSCORE_MENU_T6 = 1647,
  ID_HIGHSCORE_MENU_N7 = 1650,
  ID_HIGHSCORE_MENU_S7 = 1651,
  ID_HIGHSCORE_MENU_T7 = 1652,
  ID_HIGHSCORE_MENU_N8 = 1655,
  ID_HIGHSCORE_MENU_S8 = 1656,
  ID_HIGHSCORE_MENU_T8 = 1657,
  ID_HIGHSCORE_MENU_N9 = 1660,
  ID_HIGHSCORE_MENU_S9 = 1661,
  ID_HIGHSCORE_MENU_T9 = 1662,
  ID_HIGHSCORE_MENU_N10 = 1665,
  ID_HIGHSCORE_MENU_S10 = 1666,
  ID_HIGHSCORE_MENU_T10 = 1667,
  
  ID_CONTROL_MENU = 1700,
  ID_CONTROL_MENU_OK = 1711,
  ID_CONTROL_MENU_CANCEL = 1712,
  ID_CONTROL_MENU_THRUST_LAB = 1713,
  ID_CONTROL_MENU_THRUST = 1714,
  ID_CONTROL_MENU_ALIGN_LAB = 1715,
  ID_CONTROL_MENU_ALIGN = 1716,
  ID_CONTROL_MENU_LEFT_LAB = 1717,
  ID_CONTROL_MENU_LEFT = 1718,
  ID_CONTROL_MENU_RIGHT_LAB = 1719,
  ID_CONTROL_MENU_RIGHT = 1720,
  ID_CONTROL_MENU_FIRE_LAB = 1721,
  ID_CONTROL_MENU_FIRE = 1722,
  ID_CONTROL_MENU_PAUSE_LAB = 1723,
  ID_CONTROL_MENU_PAUSE = 1724,
  
  ID_STATUSBAR_MENU = 5000,
  ID_STATUSBAR_MENU_SCORE = 5001,
  ID_STATUSBAR_SCORE_ENTRY= 5011,
  ID_STATUSBAR_MENU_SHIP = 5002,
  ID_STATUSBAR_SHIP_ENTRY= 5012,
  ID_STATUSBAR_MENU_BONUS = 5004,
  ID_STATUSBAR_BONUS_ENTRY = 5014,
  ID_STATUSBAR_MENU_FUEL = 5003,
  ID_STATUSBAR_FUEL_ENTRY = 5013,
  ID_STATUSBAR_MESSAGE_ENTRY = 5005,

  ID_LAST = 9999
};

#endif // MENU_IDS_H

